import Color._
import Graph._
import Powerset._
import RelationSet._

object TestGraph {

  def main(args: Array[String]): Unit = {
    val s = Seq(1, 2, 3);
    val g = new UGraph(Seq(0, 1, 2, 3, 4), Seq((1, 2), (2, 3), (1,3), (2, 4), (0, 1), (0, 2))) ;
    val g2 = new UGraph(Seq(1, 2, 3, 4, 5, 6), Seq((1, 2), (1, 4), (2, 3), (2, 5), (3, 5), (3, 6), (4, 5), (5, 6))) ;
    val dg = new Graph(Seq(1, 2, 3, 4, 5,6,7,8), Seq((1,2), (2,3), (2,8), (3,4), (3,7), (4,5), (4,7), (5,6), (6,4), (7,6), (8,1)) ) ;
    val exgr1 = new UGraph(Seq(1,2,3,4,5,6), 
        Seq((1,2),(1,4),(2,3),(2,5),(3,5),(3,6),(4,5),(5,6)));
    val colorgraph = new UGraph(Seq(1,2,3,4,5,6), 
        Seq((1,2),(1,6),(3,4),(3,6),(5,2),(5,4),(5,6)));
    val p = k_partition(s, 2);
    val lst = List(List(1,2), List(3))
    val m : collection.mutable.Map[Int,Int] = collection.mutable.Map(3 -> 2, 4 -> 1, 5 -> 4, 2 -> 3)
    val ml = Map(1 -> List(2, 3), 3 -> List(4, 5, 6))

    
    //println("chi:" + exgr1.chi)
    //println("coloring:" + exgr1.min_coloring)
    println(g2.max_cliques)
    //println(dg.restrict(Seq(3,4,5)).edges)
    //println(refl_transclos( List((1,2), (2, 3), (3,2)).toSet))
    //println(k_partition(Seq(1), 2))
    //println ("g edges: " + g.edges)
    //println(g.is_clique(Seq(1, 3)))
    //println(powerset(g.vertices))
    //println(powerset(g.vertices) filter (s => g.is_clique(s)))
    //println("cliques:" + g.comp_cliques())
    // println ("res: " + colorgraph.greedyColor)
    //println ("res: " + k_partition(Seq(10, 11, 12, 13), 3))
    // List(List(List(), List(4), List(3), List(2), List(1)))
    //println ("prod: " + rel_prod (List((1,2), (1, 3), (2, 4), (3, 4), (4, 5), (4, 1))) (List((1,2), (1, 3), (2, 4))))
    //val trcl = refl_transclos((List((1,2), (1, 3), (2, 4), (3, 4), (4, 5), (4, 1))).toSet)
    //val field = relField (trcl)
    // println ("sccs: " + dg.sccs)
    // println ("reach: " + reach(dg.edges.toSet)(Set(3)))
    // println ("relimage: " + relImage((List((1,2), (1, 3), (2, 4), (3, 4), (4, 5), (4, 1))).toSet)(4))
    //println ("foo: " + transclos(List((1,2), (2, 3))))
    //println("toseq test: " + (ml).flatMap(kv => kv._2 map (x => (kv._1,x))  ))
    //println("toseq test: " + ml.flatMap(kv => kv._2 map (x => (kv._1,x))  ))
    
    val ag = new AGraph(Map("a" -> List("b","c"), "b" -> List("c","d","e"), "c" -> List(), "d" -> List(), "e" -> List("a","d")))
    //println("ag dfs: " + ag.dfs_traversal)
    //println ("search path: ")
    //(ag.search_path("a", "d")) take 3 foreach println
  }

}


